local BoxTallyMode = CrashAddon.BoxTallyMode
local ObjectSpawner = CrashAddon.ObjectSpawner

//this counts how many tvs have spawned on the map
//not counting respawnable tvs and ctf ring tvs for obvious reasons
local TVSpawn = {
	[400] = true,
	[401] = true,
	[402] = true,
	[403] = true,
	[404] = true,
	[405] = true,
	[406] = true,
	[407] = true,
	[408] = true,
	[410] = true,
	[411] = true,
	[412] = true,
	[413] = true,
	[416] = true,
	[418] = true,
	[419] = true,
	[420] = true,
	[421] = true,
	[422] = true
}

//table for checking if a map has already spawned in boxes to not count tvs
local BoxSpawn = {
	[4030] = true,
	[4031] = true,
	[4032] = true,
	[4033] = true,
	[4034] = true,
	[4035] = true,
	[4036] = true
}

//failsafe
local BoxChecker = {
	[MT_BLANKBOX] = true,
	[MT_NITROBOX] = true,
	[MT_TNTBOX] = true,
	[MT_AKUAKUBOX] = true,
	[MT_RINGCRATE] = true,
	[MT_BOUNCEBOX] = true,
	[MT_BOUNCESTEEL] = true
}

local function BoxCounter(mo, mapthing)
	if not BoxTallyMode()
		return
	end
	if CrashAddon.boxtotal < 0
		CrashAddon.boxcount = 0
		CrashAddon.boxtotal = 0
	end
	if TVSpawn[mapthing.type] and CrashAddon.boxtotal >= 0 and not
			CrashAddon.crashmap
		CrashAddon.boxcount = $ + 1
		CrashAddon.boxtotal = CrashAddon.boxcount
		mo.crashmapbox = true
		if mo.type == MT_EGGMAN_BOX
			CrashAddon.theresnitro = true
		end
	elseif BoxSpawn[mapthing.type] and BoxChecker[mo.type] and
			CrashAddon.boxtotal >= 0
		if not CrashAddon.crashmap
			CrashAddon.boxcount = 0
			CrashAddon.boxtotal = 0
			CrashAddon.crashmap = true
		end
		if mo.type != MT_BOUNCESTEEL
			CrashAddon.boxcount = $ + 1
			CrashAddon.boxtotal = CrashAddon.boxcount
			mo.crashmapbox = true
			if mo.type == MT_NITROBOX
				CrashAddon.theresnitro = true
			end
		end
	end
	//this spawns in the nitro detonator and final box in front of the goal post
	if mapthing.type == 501
		local nitroswitch = ObjectSpawner(mo, MT_NITROSTEEL)
		nitroswitch.tracer = mo
		nitroswitch.changepos = 5
		local finalbox = ObjectSpawner(mo, MT_BLANKBOX)
		finalbox.tracer = mo
		finalbox.changepos = 3
		finalbox.rewardbox = true
		CrashAddon.isvalidlevel = true
	end
	//this sets up deletion of all the emerald tokens in the level
	if mapthing.type == 312
		mo.crashmaptoken = true
	end
end

//function to save box tally progress in singleplayer
CrashAddon.BoxProgressSaver = function(player)
	if multiplayer
		return
	end
	
	if player.starposttime != nil and player.starposttime != 0 and
			player.starposttime != player.crash_lastpoint
		CrashAddon.boxprogress = CrashAddon.boxtotal - CrashAddon.boxcount
		player.crash_lastpoint = player.starposttime
	elseif player.starposttime == nil or player.starposttime == 0
		CrashAddon.boxprogress = 0
	end
end

//hooks
addHook("MapThingSpawn", BoxCounter)
//this resets the count when the map changes
addHook("MapChange", function(mapnum)
	CrashAddon.boxcount = -1
	CrashAddon.boxtotal = -1
	CrashAddon.theresnitro = false
	CrashAddon.nitrodetonator = -1
	CrashAddon.isvalidlevel = false
	CrashAddon.boxes = {}
	CrashAddon.crashmap = false
end)