local BoxTallyMode = CrashAddon.BoxTallyMode
local PlayerCamera = CrashAddon.PlayerCamera

local function CompassThinker(mo)
	//failsafe
	if not mo.tracer or not mo.tracer.valid or not mo.tracer.player or not
			BoxTallyMode() or not CrashAddon.globalpointer or not 
			mo.tracer.player.crash_boxpointer or CrashAddon.boxcount <= 0 or
			not CrashAddon.isvalidlevel
		P_RemoveMobj(mo)
		return
	end
	
	//change the appearance based on perspective
	local cam = PlayerCamera(mo.tracer.player)
	if cam != nil
		if cam.chase
			mo.frame = $ | FF_PAPERSPRITE & ~FF_FLOORSPRITE
			mo.renderflags = $ & ~RF_NOSPLATBILLBOARD
			mo.spriteroll = ANGLE_270
		else
			mo.frame = $ | FF_FLOORSPRITE & ~FF_PAPERSPRITE
			mo.renderflags = $ | RF_NOSPLATBILLBOARD
			mo.spriteroll = 0
		end
	end
	mo.drawonlyforplayer = mo.tracer.player
	local x = mo.tracer.x
	local y = mo.tracer.y
	local z = mo.tracer.z
	//start a search for the closest box to point towards
	local temp
	mo.closedist = INT32_MAX
	for i, boxes in ipairs(CrashAddon.boxes) do
		if boxes == nil or not boxes.valid or boxes.type == MT_NITROBOX or
				boxes.state == S_CRASH_BLANK
			continue
		end
		local h_dist = R_PointToDist2(x, y, boxes.x, boxes.y)
		temp = R_PointToDist2(0, z, h_dist, boxes.z)
		if temp < mo.closedist
			mo.closedist = temp
			mo.target = boxes
		end
	end
	if not mo.target or not mo.target.valid
		P_RemoveMobj(mo)
		return
	end
	//point towards the closest box
	mo.angle = R_PointToAngle2(x, y, mo.target.x, mo.target.y)
	local hight = mo.tracer.height / 2
	if mo.tracer.eflags & MFE_VERTICALFLIP
		hight = 0
	end
	P_MoveOrigin(mo, x + P_ReturnThrustX(mo, mo.angle, 75 * mo.tracer.scale), 
			y + P_ReturnThrustY(mo, mo.angle, 75 * mo.tracer.scale), z + hight)
	//change the appearance based on distance of closest box
	mo.frame = $ & ~FF_TRANSMASK
	local blink
	if mo.closedist <= 100 * FRACUNIT
		blink = 1
	elseif mo.closedist <= 1000 * FRACUNIT
		mo.color = SKINCOLOR_RED
		mo.scale = mo.tracer.scale
		mo.frame = $ | FF_TRANS10
		blink = 3
	elseif mo.closedist <= 3000 * FRACUNIT
		mo.color = SKINCOLOR_TOPAZ
		mo.scale = mo.tracer.scale - (mo.tracer.scale / 4)
		mo.frame = $ | FF_TRANS30
		blink = 6
	elseif mo.closedist <= 7500 * FRACUNIT
		mo.color = SKINCOLOR_GREEN
		mo.scale = mo.tracer.scale / 2
		mo.frame = $ | FF_TRANS50
		blink = 12
	else
		mo.color = SKINCOLOR_WHITE
		mo.scale = mo.tracer.scale / 4
		mo.frame = $ | FF_TRANS70
		blink = 24
	end
	if leveltime % blink == 0
		if blink == 1
			mo.flags2 = $ | MF2_DONTDRAW
		else
			mo.flags2 = $ & ~MF2_DONTDRAW
			if mo.frame & FF_ADD
				mo.frame = $ & ~FF_ADD
			else
				mo.frame = $ | FF_ADD
			end
		end
	end
end

CrashAddon.CompassSpawner = function(player)
	if not BoxTallyMode() or not CrashAddon.globalpointer or not 
			player.crash_boxpointer or CrashAddon.boxcount <= 0 or not
			CrashAddon.isvalidlevel
		if player.crash_boxcompass != nil
			player.crash_boxcompass = nil
		end
		return
	end
	
	//spawn in the radar if there isn't one
	if player.crash_boxcompass == nil or not player.crash_boxcompass.valid
		player.crash_boxcompass = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, 
				MT_BOXPOINTER)
		player.crash_boxcompass.tracer = player.mo
	end
end

//hooks
addHook("MobjThinker", CompassThinker, MT_BOXPOINTER)