local CrashSkinCheck = CrashAddon.CrashSkinCheck
local JumpManager = CrashAddon.JumpManager
local FailVibeCheck = CrashAddon.FailVibeCheck
local CootOnGround = CrashAddon.CootOnGround
local StateSetter = CrashAddon.StateSetter

//this makes crash jump higher if he jumps while crawling/sliding
local function SlideNCrouchJump(player)
	if not CrashSkinCheck(player)
		return
	end
	
	local crashban = player.crashban
	if player.normalspeed < skins[player.mo.skin].normalspeed or 
			crashban.slidetimer > 0
		P_DoJump(player, true)
		JumpManager(player.mo, 3 * FRACUNIT, true)
		player.height = skins[player.mo.skin].height
		player.normalspeed = skins[player.mo.skin].normalspeed
		crashban.slidetimer = 0
		crashban.slidejumped = true
		return true
	end
end

//this helps reset the slidejump variable
CrashAddon.SlideJumpReset = function(player)
	if not CrashSkinCheck(player)
		return
	end
	
	/*failsafes because of that one vanilla bug where tall characters have their 
	jump & spin states bugged if they jump inside a spin gap*/
	if CootOnGround(player.mo) and player.pflags & PF_JUMPED
		player.pflags = $ & ~PF_JUMPED
	end
	if player.pflags & PF_SPINNING
		StateSetter(player.mo, S_PLAY_ROLL)
	end
	local crashban = player.crashban
	if (FailVibeCheck(player) or not (player.pflags & PF_JUMPED)) and
			crashban.slidejumped
		crashban.slidejumped = false
	end
end

//hooks
addHook("JumpSpecial", SlideNCrouchJump)