local CrashSkinCheck = CrashAddon.CrashSkinCheck
local FailVibeCheck = CrashAddon.FailVibeCheck
local CootOnGround = CrashAddon.CootOnGround
local SpeedCalc = CrashAddon.SpeedCalc
local StateSetter = CrashAddon.StateSetter

//funny easter egg
CrashAddon.EasterEgg = function(player)
	if not CrashSkinCheck(player)
		return
	end
	
	local crashban = player.crashban
	//this resets everything and prevents moves if crash fails the vibe check
	if FailVibeCheck(player) or crashban.actionpress or crashban.spinpress
			or crashban.spintimer > 0 or crashban.slidetimer > 0
			or crashban.faceplant > 0
		crashban.woah = false
		return
	end
	
	if (player.cmd.buttons & BT_CUSTOM3 and player.cmd.buttons & BT_TOSSFLAG) 
			and CootOnGround(player.mo) and (SpeedCalc(player) == 0 or 
			(player.cmd.forwardmove == 0 and player.cmd.sidemove == 0))
		if not crashban.woah
			S_StartSound(player.mo, sfx_woah)
			crashban.woah = true
		end
	elseif not CootOnGround(player.mo) or (SpeedCalc(player) != 0 and
			(player.cmd.forwardmove != 0 or player.cmd.sidemove != 0))
			or player.cmd.buttons & BT_SPIN or player.cmd.buttons & BT_CUSTOM1 
			or player.pflags & PF_SPINNING and crashban.woah
		crashban.woah = false
	end
	if crashban.woah
		StateSetter(player.mo, S_PLAY_FLY_TIRED)
	end
end

//funni feature where the tornado spin knocks back other players
local function TornadoKnockback(thing, tmthing)
	local crash
	local victim
	if thing != nil and thing.valid and thing.player != nil and 
			thing.player.valid and thing.skin == "crashbandi"
		crash = thing
		victim = tmthing
	elseif tmthing != nil and tmthing.valid and tmthing.player != nil
			and tmthing.player.valid and tmthing.skin == "crashbandi"
		crash = tmthing
		victim = thing
	end
	if victim != nil and victim.valid and victim.player != nil and
			victim.player.valid and victim.state != S_PLAY_PAIN and
			crash != nil and crash.player.crashban != nil and
			crash.player.crashban.spintimer > 0 and 
			crash.z >= victim.z - victim.height and 
			crash.z <= victim.z + victim.height
		//have 2 crashes fling each other
		if victim.skin == "crashbandi" and victim.player.crashban != nil
				and crash.player.crashban.spintimer > 0
			P_DoPlayerPain(crash.player)
			crash.player.powers[pw_flashing] = 0
			S_StartSound(crash, sfx_cshpew)
		end
		P_DoPlayerPain(victim.player)
		victim.player.powers[pw_flashing] = 0
		S_StartSound(victim, sfx_cshpew)
	end
end

//hooks
addHook("MobjCollide", TornadoKnockback, MT_PLAYER)
addHook("MobjMoveCollide", TornadoKnockback, MT_PLAYER)