local CrashSkinCheck = CrashAddon.CrashSkinCheck
local IsNiGHTS = CrashAddon.IsNiGHTS
local SuperSprites = CrashAddon.SuperSprites

//this handles how Aku Aku spawns in
CrashAddon.AkuSpawnAndDie = function(player)
	if not CrashSkinCheck(player)
		return
	end
	
	local crashban = player.crashban
	if player.playerstate != PST_LIVE
		if crashban.akulevel > 0 or crashban.aku != nil
			crashban.akulevel = 0
			crashban.aku = nil
		end
		return
	end
	//this adds to the aku level and removes the shield when Crash gets one
	if player.powers[pw_shield]
		//ignore shields given by both amy and adventure sonic
		//wish i have a better way of ignoring player-given shields
		if player.powers[pw_shield] != SH_PINK and player.powers[pw_shield] !=
				SH_YUSUPERSHIELD
			if not player.powers[pw_invulnerability] and not 
					player.powers[pw_super]
				crashban.akulevel = min($ + 1, 3)
			end
			player.powers[pw_shield] = SH_NONE
		end
	end
	//this either spawns in Aku Aku or kills him based on aku level
	if not IsNiGHTS(player)
		if crashban.akulevel <= 0 and not (player.powers[pw_invulnerability] or
				player.powers[pw_super])
			if crashban.aku != nil
				crashban.aku = nil
			end
		else
			if crashban.aku == nil or not crashban.aku.valid and 
					crashban.akulevel > 0
				crashban.aku = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_AKUAKU)
				crashban.aku.target = player.mo
				S_StartSound(player.mo, sfx_akuspn, player)
			end
			if player.powers[pw_invulnerability] or player.powers[pw_super] or
					SuperSprites[player.mo.state]
				crashban.akulevel = 3
			end
		end
		//this gives additional attack properties to crash while max aku level
		local mrpowers = STR_ATTACK|STR_SPIKE
		if crashban.akulevel >= 3
			player.powers[pw_strong] = $ | mrpowers
			//this prevents drowning while aku aku invincibility is active
			if player.mo.eflags & MFE_UNDERWATER or player.mo.eflags & 
					MFE_GOOWATER
				player.powers[pw_underwater] = 30 * TICRATE
			elseif P_InSpaceSector(player.mo)
				player.powers[pw_spacetime] = 11 * TICRATE
			end
		elseif player.powers[pw_strong] == mrpowers
			player.powers[pw_strong] = STR_NONE
		end
	end
end

//this determines what happens if Crash gets hit
local function CrashDamage(target, inflictor, source, damage, damagetype)
	if target.skin != "crashbandi" or IsNiGHTS(target.player)
		return
	end
	
	if target.player.crashban.akulevel <= 0
		P_KillMobj(target, inflictor, source, damagetype)
	else
		target.player.crashban.akulevel = max($ - 1, 0)
		P_PlayRinglossSound(target)
		P_DoPlayerPain(target.player, source, inflictor)
		S_StartSound(target, sfx_akuded, target.player)
	end
	return true
end

//hooks
addHook("MobjDamage", CrashDamage, MT_PLAYER)
//this makes it so crash can't grab air bubbles while under aku aku invincibility
addHook("TouchSpecial", function(special, toucher)
	if toucher.skin == "crashbandi" and toucher.player.crashban.akulevel == 3
		return true
	end
end, MT_EXTRALARGEBUBBLE)