local CrashSkinCheck = CrashAddon.CrashSkinCheck
local StateSetter = CrashAddon.StateSetter
local CanSupper = CrashAddon.CanSupper
local SuperSprites = CrashAddon.SuperSprites
local JumpManager = CrashAddon.JumpManager
local ObjectSpawner = CrashAddon.ObjectSpawner

//a whole transformation sequence
CrashAddon.SuperTransform = function(player)
	if not CrashSkinCheck(player)
		return
	end
	
	local crashban = player.crashban
	//failsafe for if crash is no longer super
	if (crashban.supertrans or player.charflags & SF_SUPER) and not 
			(player.powers[pw_super] or SuperSprites[player.mo.state])
			and crashban.transtimer < 0
		player.charflags = $ & ~SF_SUPER
		crashban.supertrans = false
	end
	//sets up start of transformation sequence
	if CanSupper(player) and player.cmd.buttons & BT_SPIN and not 
			crashban.supertrans
		player.charflags = $ | SF_SUPER
		crashban.transtimer = 2 * TICRATE + TICRATE / 3
		crashban.akulevel = 4
		S_FadeOutStopMusic(2 * MUSICRATE, player)
		crashban.supertrans = true
	end
	//this handles the actual transformation sequence
	if crashban.transtimer > 0
		StateSetter(player.mo, S_PLAY_SPRING)
		crashban.transtimer = $ - 1
		A_ForceStop(player.mo, 0)
		player.pflags = $ | PF_FULLSTASIS
		player.charflags = $ | SF_SUPER
	elseif crashban.transtimer == 0
		player.charflags = $ | SF_SUPER
		P_DoSuperTransformation(player, false)
		crashban.transtimer = $ - 1
	end
	//this handles aku aku's behavior during the super transformation sequence
	local aku = crashban.aku
	if aku != nil and aku.valid
		if crashban.transtimer > TICRATE / 2
			if crashban.transtimer == 2 * TICRATE + TICRATE / 3 - 1
				local akuheight
				if aku.eflags & MFE_VERTICALFLIP
					akuheight = player.mo.height / 2 * -1
				else
					akuheight = player.mo.height
				end
				P_MoveOrigin(aku, player.mo.x, player.mo.y, player.mo.z + 
						akuheight)
			end
			JumpManager(aku, 1 * FRACUNIT + FRACUNIT / 2)
			aku.angle = $ + ANGLE_22h
		elseif crashban.transtimer >= 3
			if crashban.transtimer == TICRATE / 2
				S_StartSound(target, sfx_akuspn)
				local akusparks = ObjectSpawner(aku, MT_IVSP)
				akusparks.colorized = true
				akusparks.frame = $ | FF_ADD
				akusparks.color = SKINCOLOR_GOLDENROD
			end
			A_ForceStop(aku, 0)
			aku.angle = camera.angle + ANGLE_180
			if leveltime % 2 == 0
				if aku.colorized
					aku.colorized = false
				else
					aku.colorized = true
					aku.color = SKINCOLOR_SUPERGOLD1
				end
			end
		else
			JumpManager(aku, -15 * FRACUNIT)
		end
	end
end