local StateSetter = CrashAddon.StateSetter
local JumpManager = CrashAddon.JumpManager

//handles the behavior and death of bounce crate
local function BounceBoxHit(target, inflictor)
	if inflictor and inflictor.valid
		if (inflictor.type == MT_PLAYER and inflictor.player) and 
				(inflictor.player.pflags & PF_JUMPED or 
				inflictor.state == S_PLAY_SPRING or 
				inflictor.state == S_PLAY_FALL)
			StateSetter(target, S_BOUNCEBOXHIT)
			S_StartSound(target, sfx_boxbnc)
			JumpManager(inflictor, 16 * FRACUNIT)
			return false
		else
			return true
		end
	end
end

//applies the bounce behavior to the steel variant
local function BounceSteelHit(target, inflictor)
	if inflictor and inflictor.valid
		if (inflictor.type == MT_PLAYER and inflictor.player) and 
				(inflictor.player.pflags & PF_JUMPED or 
				inflictor.state == S_PLAY_SPRING or 
				inflictor.state == S_PLAY_FALL)
			StateSetter(target, S_BOUNCESTEELHIT)
			S_StartSound(target, sfx_boxbnc)
			JumpManager(inflictor, 16 * FRACUNIT)
		end
	end
	return false
end

//hooks
addHook("ShouldDamage", BounceBoxHit, MT_BOUNCEBOX)
addHook("ShouldDamage", BounceSteelHit, MT_BOUNCESTEEL)