local ObjectSpawner = CrashAddon.ObjectSpawner

//a rather basic death function for a basic type of box
local function BlankDeath(target)
	if target.crashmapbox
		CrashAddon.boxcount = $ - 1
		target.crashmapbox = nil
	//except this specific blank box is used for handing out rewards
	elseif target.rewardbox
		local reward
		if CrashAddon.boxcount <= 0
			//thank you Tatsuru for the help with the for loop
			local gem = MT_TOKEN
			for i = 0, 6 do
				if not (emeralds & (1 << i))
					gem = MT_EMERALD1 + i
					break
				end
			end
			reward = ObjectSpawner(target, gem)
			if All7Emeralds(emeralds)
				local addreward = ObjectSpawner(target, MT_TOKEN)
			end
		elseif CrashAddon.boxcount <= CrashAddon.boxtotal / 2
			reward = ObjectSpawner(target, MT_TOKEN)
		else
			return
		end
		target.rewardbox = nil
	end
end

//thinker for the blank box that acts as the reward box
local function RewardBox(mo)
	if mo.rewardbox
		if mo.tracer and mo.tracer.type == MT_SIGN and mo.changepos <= 0
			if CrashAddon.boxtotal > 0
				mo.angle = mo.tracer.angle
				local rewardx = mo.tracer.x + P_ReturnThrustX(mo, mo.angle, 
						150 * mo.scale)
				local rewardy = mo.tracer.y + P_ReturnThrustY(mo, mo.angle, 
						150 * mo.scale)
				P_MoveOrigin(mo, rewardx, rewardy, mo.tracer.z)
				//here's where the total tally gets adjusted for singleplayer
				if not (multiplayer or CrashAddon.crashmap) or 
						CrashAddon.easymultiplayer
					if CrashAddon.boxtotal >= 100
						CrashAddon.boxtotal = $ / 4
					elseif CrashAddon.boxtotal >= 50
						CrashAddon.boxtotal = $ / 2
					elseif CrashAddon.boxtotal > 20
						CrashAddon.boxtotal = $ - ($ / 4)
					end
					CrashAddon.boxcount = CrashAddon.boxtotal - 
							CrashAddon.boxprogress
				end
				mo.tracer = nil
				mo.changepos = nil
			else
				P_RemoveMobj(mo)
				return
			end
		elseif mo.changepos
			mo.changepos = $ - 1
		end
		mo.frame = $ | FF_ADD | FF_FULLBRIGHT
	end
end

//hooks
addHook("MobjDeath", BlankDeath, MT_BLANKBOX)
addHook("MobjDeath", BlankDeath, MT_RINGCRATE)
addHook("MobjDeath", BlankDeath, MT_BOUNCEBOX)
addHook("MobjThinker", RewardBox, MT_BLANKBOX)