local ObjectSpawner = CrashAddon.ObjectSpawner

//making an enemy blacklist because some break when their deaths are messed with
local NoFlingers = {
	[MT_CRUSHSTACEAN] = true,
	[MT_BANPYURA] = true,
	[MT_POINTY] = true,
	[MT_GSNAPPER] = true,
	[MT_YELLOWSHELL] = true,
	[MT_DRAGONBOMBER] = true
}

//have crash knock back enemies when he kills them
local function CorpseSpawner(target, inflictor)
	if inflictor != nil and inflictor.valid and inflictor.skin == "crashbandi" 
			and target != nil and target.valid and target.flags & MF_ENEMY 
			and not (target.flags & MF_BOSS or NoFlingers[target.type])
			and target.info.spawnhealth < 2
		if inflictor.player.crashban.spintimer > 0
			S_StartSound(inflictor, sfx_cshpew)
			local corpse = ObjectSpawner(target, MT_CRASHCORPSE)
			corpse.target = target
			corpse.tracer = inflictor
			corpse.angle = R_PointToAngle2(inflictor.x, inflictor.y, corpse.x, 
					corpse.y)
			return true
		end
	end
end

//handle the death function for the corpse
local function CorpseDeath(mo)
	mo.target.state = S_DEATHSTATE
	P_RemoveMobj(mo)
end

//simple thinker for the corpse
local function CorpseThinker(mo)
	P_InstaThrust(mo, mo.angle, 30 * mo.target.scale)
	mo.target.spriteroll = $ + ANGLE_45
	P_MoveOrigin(mo.target, mo.x, mo.y, mo.z)
	//failsafe
	if mo.momx == 0 and mo.momy == 0 and mo.momz == 0
		CorpseDeath(mo)
	end
end

//kamikaze if the corpse collides with another player
local function CorpseCollide(thing, tmthing)
	local corpse
	local victim
	if thing != nil and thing.valid and thing.type == MT_CRASHCORPSE
		corpse = thing
		victim = tmthing
	elseif tmthing != nil and tmthing.valid and tmthing.type == MT_CRASHCORPSE
		corpse = tmthing
		victim = thing
	end
	if corpse != nil and victim != nil and victim.type != MT_CRASHCORPSE
		if corpse.z >= victim.z - victim.height and corpse.z <= victim.z + 
				victim.height
			if corpse.tracer != victim and (victim.health or victim.player)
				P_DamageMobj(victim, corpse, corpse.tracer, 1)
				CorpseDeath(corpse)
			end
		end
	end
end

addHook("MobjDeath", CorpseSpawner)
addHook("MobjThinker", CorpseThinker, MT_CRASHCORPSE)
addHook("MobjCollide", CorpseCollide)
addHook("MobjMoveCollide", CorpseCollide)
//kill the corpse if it collides with something that isn't an object
addHook("MobjMoveBlocked", function(mo, thing, line)
	CorpseDeath(mo)
end, MT_CRASHCORPSE)