local JumpManager = CrashAddon.JumpManager
local ObjectSpawner = CrashAddon.ObjectSpawner

//this makes the nitro box bounce up occasionally
local function NitroBounce(mo)
	//this kills the nitro box id the nitro detonator has been activated
	if CrashAddon.nitrodetonator == 0
		P_KillMobj(mo)
		return
	end
	if P_RandomChance(FRACUNIT / 100) and P_IsObjectOnGround(mo)
		JumpManager(mo, 5 * FRACUNIT)
		S_StartSound(mo, sfx_ntrbnc)
	end
end

//this automatically kills the nitro box when touched
local function NitroNoTouch(thing, tmthing)
	if tmthing.type == MT_PLAYER
		if tmthing.z >= thing.z - thing.height and tmthing.z <= thing.z + 
				thing.height
			P_KillMobj(thing)
		end
	end
end

//this makes the box explode when it dies
local function NitroDeath(target)
	if target.crashmapbox
		CrashAddon.boxcount = $ - 1
		target.crashmapbox = nil
	end
	local nitroexplode = ObjectSpawner(target, MT_TNTBARREL)
	nitroexplode.colorized = true
	nitroexplode.color = SKINCOLOR_GREEN
	P_KillMobj(nitroexplode)
end

//has to be a function because signposts always spawn before their angle is set
local function NitroSwitchPos(mo)
	if mo.tracer and mo.tracer.type == MT_SIGN and mo.changepos <= 0
		if CrashAddon.theresnitro
			mo.angle = mo.tracer.angle
			local nitrox = mo.tracer.x + P_ReturnThrustX(mo, mo.angle, 300 * 
					mo.scale)
			local nitroy = mo.tracer.y + P_ReturnThrustY(mo, mo.angle, 300 * 
					mo.scale)
			P_MoveOrigin(mo, nitrox, nitroy, mo.tracer.z)
			CrashAddon.nitrodetonator = 1
			mo.tracer = nil
			mo.changepos = nil
		else
			P_RemoveMobj(mo)
		end
	elseif mo.changepos
		mo.changepos = $ - 1
	end
end

//this determines what happens when the nitro detonator has been activated
local function NitroSwitchHit(target, inflictor)
	CrashAddon.nitrodetonator = 0
	for i = 0, 360, 90 do
		local effect = ObjectSpawner(target, MT_SWITCHPOINT, 0, 0, 
				target.height / 2)
		effect.fuse = TICRATE
		P_InstaThrust(effect, FixedAngle(i * FRACUNIT), 5 * effect.scale)
	end
end

//thinker for the nitro switch effects
local function EffectThinker(mo)
	if mo.fuse <= 0
		P_RemoveMobj(mo)
		return
	else
		if mo.fuse <= TICRATE / 2
			mo.frame = $ | FF_TRANS50
		end
		mo.fuse = $ - 1
	end
end

//hooks
addHook("MobjThinker", NitroBounce, MT_NITROBOX)
addHook("MobjCollide", NitroNoTouch, MT_NITROBOX)
addHook("MobjDeath", NitroDeath, MT_NITROBOX)
addHook("MobjThinker", NitroSwitchPos, MT_NITROSTEEL)
addHook("MobjDeath", NitroSwitchHit, MT_NITROSTEEL)
addHook("MobjThinker", EffectThinker, MT_SWITCHPOINT)