local StateSetter = CrashAddon.StateSetter
local ObjectSpawner = CrashAddon.ObjectSpawner

//this determines if the box blows up immediately or starts the countdown
local function TNTTrigger(target, inflictor)
	if inflictor and inflictor.valid
		if (inflictor.type == MT_PLAYER and inflictor.player) and 
				(inflictor.player.pflags & PF_JUMPED or 
				inflictor.state == S_PLAY_SPRING or 
				inflictor.state == S_PLAY_FALL)
			StateSetter(target, S_TNTCOUNT)
			S_StartSound(target, sfx_boxbnc)
			inflictor.momz = $ * -1
			return false
		else
			return true
		end
	end
end

//this handles what happens during the countdown
local function TNTSound(mo)
	if mo.state == S_TNTCOUNT
		if not mo.soundcue
			S_StartSound(mo, sfx_tntcnt)
			mo.soundcue = true
		end
		A_ForceStop(mo, 0)
	elseif mo.state == S_BLANKTNT
		P_KillMobj(mo)
	end
end

//this makes the tnt box explode upon death
local function TNTDeath(target)
	if target.crashmapbox
		CrashAddon.boxcount = $ - 1
		target.crashmapbox = nil
	end
	local tntexplode = ObjectSpawner(target, MT_TNTBARREL)
	P_KillMobj(tntexplode)
end

//hooks
addHook("ShouldDamage", TNTTrigger, MT_TNTBOX)
addHook("MobjThinker", TNTSound, MT_TNTBOX)
addHook("MobjDeath", TNTDeath, MT_TNTBOX)