local CrashSkinCheck = CrashAddon.CrashSkinCheck
local CootOnGround = CrashAddon.CootOnGround

//custom function, a modified version of Emmette's footsteps code
local function FootstepCue(player, fram1, fram2)
	local crashban = player.crashban
	
	local fram = player.mo.frame & FF_FRAMEMASK
	if crashban.currentfram != fram
		if fram == fram1
			S_StartSound(player.mo, sfx_cshft1)
		elseif fram == fram2
			S_StartSound(player.mo, sfx_cshft2)
		end
		crashban.currentfram = fram
	end
end

CrashAddon.SoundStuff = function(player)
	if not CrashSkinCheck(player)
		return
	end
	
	local crashban = player.crashban
	//this cancels the default 1-up jingle to make way for crash's 1-up sfx
	if player.powers[pw_extralife]
		S_StartSound(player.mo, sfx_cshlfe, player)
		player.powers[pw_extralife] = 0
		P_RestoreMusic(player)
	end
	//this controls when the footsteps play based on animation
	if CootOnGround(player.mo)
		if player.mo.state == S_PLAY_WALK
			FootstepCue(player, 2, 6)
		elseif player.mo.state == S_PLAY_RUN
			FootstepCue(player, 1, 3)
		end
	end
	//this changes the drowning theme
	if player.powers[pw_underwater] == 11 * TICRATE
		P_PlayJingleMusic(player, "DRWCSH", 0, false, JT_DROWN)
	end
	//this changes the speed shoes music
	if player.powers[pw_sneakers]
		if not crashban.shoesmusic
			P_PlayJingleMusic(player, "CSHSHS", 0, true, JT_SHOES)
			crashban.shoesmusic = true
		end
	elseif crashban.shoesmusic
		crashban.shoesmusic = false
	end
	//this changes the invincibility theme
	if player.powers[pw_invulnerability]
		if not crashban.invulnmusic
			P_PlayJingleMusic(player, "CSHINV", 0, true, JT_INV)
			crashban.invulnmusic = true
		end
	elseif crashban.invulnmusic
		crashban.invulnmusic = false
	end
	//this changes the super theme
	if player.powers[pw_super]
		if not crashban.supermusic
			P_PlayJingleMusic(player, "SPRCSH", 0, true, JT_SUPER)
			crashban.supermusic = true
		end
	elseif crashban.supermusic
		crashban.supermusic = false
	end
end

//overriding the 1-up action for cases where pw_extralife isn't gonna work
function A_ExtraLife(actor)
	super(actor)
	local player = actor.target.player
	if actor.target.skin == "crashbandi" and not player.powers[pw_extralife]
		S_StartSound(actor.target, sfx_cshlfe, player)
	end
end