local CrashSkinCheck = CrashAddon.CrashSkinCheck
local FailVibeCheck = CrashAddon.FailVibeCheck
local StateSetter = CrashAddon.StateSetter
local CootOnGround = CrashAddon.CootOnGround
local IsFalling = CrashAddon.IsFalling
local isNiGHTS = CrashAddon.IsNiGHTS
local ObjectSpawner = CrashAddon.ObjectSpawner

//a custom function for setting jump states specifically
local function JumpMode(mo)
	if mo.state != S_PLAY_JUMP and mo.state != S_PLAY_FALL
		mo.state = S_PLAY_JUMP
	end
end

//a function since all the different states share the exact same setup
local function JumpAnimations(mo, sstate)
	local check
	if mo.eflags & MFE_VERTICALFLIP
		check = mo.momz >= 5 * mo.scale * -1
	else
		check = mo.momz <= 5 * mo.scale
	end
	if check and (not IsFalling(mo) or mo.momz == 0)
		StateSetter(mo, sstate)
	else
		JumpMode(mo)
	end
end

CrashAddon.VisualEffects = function(player)	
	if not CrashSkinCheck(player)
		return
	end
	
	local crashban = player.crashban
	//spawns in smoke for the special stages, because jetpack
	if isNiGHTS(player)
		local radius = player.mo.radius / player.mo.scale
		local smokex = P_RandomRange(radius * -1, radius) * player.mo.scale
		local smokey = P_RandomRange(radius * -1, radius) * player.mo.scale
		local smokefx = ObjectSpawner(player.mo, MT_SMOKE, smokex, smokey, 
				player.mo.height / 2)
	end
	
	if FailVibeCheck(player) or crashban.spintimer > 0 or crashban.bodyslam
		return
	end
	//just some changes to crash's jump animations based on certain conditions
	if player.pflags & PF_JUMPED and not CootOnGround(player.mo)
		if crashban.slidejumped
			JumpAnimations(player.mo, S_PLAY_FLY)
		elseif player.pflags & PF_THOKKED
			if not IsFalling(player.mo, 0) or player.mo.momz == 0
				StateSetter(player.mo, S_PLAY_FLOAT)
			else
				JumpMode(player.mo)
			end
		else
			JumpAnimations(player.mo, S_PLAY_ROLL)
		end
	end
	
	//sparkle effects for crash's super form
	if player.powers[pw_super] and leveltime % 5 == 0
		local crashsprks = ObjectSpawner(player.mo, MT_IVSP)
		crashsprks.colorized = true
		crashsprks.frame = $ | FF_ADD
		crashsprks.color = SKINCOLOR_GOLDENROD
	end
end